'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _projectGuess = require('project-guess');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var YoBasePrompts = function () {
  function YoBasePrompts(yo) {
    _classCallCheck(this, YoBasePrompts);

    this.yo = yo;
  }

  _createClass(YoBasePrompts, [{
    key: 'prompt',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(prompts) {
        var result;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                result = {};

                if (!(!prompts || prompts.name)) {
                  _context.next = 5;
                  break;
                }

                _context.next = 4;
                return this.namePromt();

              case 4:
                result.name = _context.sent;

              case 5:
                if (!(!prompts || prompts.destination)) {
                  _context.next = 9;
                  break;
                }

                _context.next = 8;
                return this.destinationPrompt(result.name);

              case 8:
                result.destination = _context.sent;

              case 9:
                if (!(!prompts || prompts.description)) {
                  _context.next = 13;
                  break;
                }

                _context.next = 12;
                return this.descriptionPrompt();

              case 12:
                result.description = _context.sent;

              case 13:
                if (!(!prompts || prompts.version)) {
                  _context.next = 17;
                  break;
                }

                _context.next = 16;
                return this.versionPrompt();

              case 16:
                result.version = _context.sent;

              case 17:
                if (!(!prompts || prompts.license)) {
                  _context.next = 21;
                  break;
                }

                _context.next = 20;
                return this.licensePrompt();

              case 20:
                result.license = _context.sent;

              case 21:
                if (!(!prompts || prompts.authorName)) {
                  _context.next = 25;
                  break;
                }

                _context.next = 24;
                return this.authorNamePrompt();

              case 24:
                result.authorName = _context.sent;

              case 25:
                if (!(!prompts || prompts.authorEmail)) {
                  _context.next = 29;
                  break;
                }

                _context.next = 28;
                return this.authorEmailPrompt();

              case 28:
                result.authorEmail = _context.sent;

              case 29:
                if (!(!prompts || prompts.githubUsername)) {
                  _context.next = 33;
                  break;
                }

                _context.next = 32;
                return this.githubUsernamePrompt(result.email);

              case 32:
                result.githubUsername = _context.sent;

              case 33:
                if (!(!prompts || prompts.authorUrl)) {
                  _context.next = 37;
                  break;
                }

                _context.next = 36;
                return this.authorUrlPrompt(result.githubUsername);

              case 36:
                result.authorUrl = _context.sent;

              case 37:
                if (!(!prompts || prompts.repository)) {
                  _context.next = 41;
                  break;
                }

                _context.next = 40;
                return this.repositoryPrompt(result.githubUsername, result.name);

              case 40:
                result.repository = _context.sent;

              case 41:
                if (!(!prompts || prompts.homepage)) {
                  _context.next = 45;
                  break;
                }

                _context.next = 44;
                return this.homepagePrompt(result.repository);

              case 44:
                result.homepage = _context.sent;

              case 45:
                return _context.abrupt('return', result);

              case 46:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function prompt(_x) {
        return _ref.apply(this, arguments);
      }

      return prompt;
    }()
  }, {
    key: 'namePromt',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                return _context2.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'name',
                  message: 'Project Name:',
                  default: (0, _projectGuess.guessProjectName)()
                }));

              case 1:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function namePromt() {
        return _ref2.apply(this, arguments);
      }

      return namePromt;
    }()
  }, {
    key: 'destinationPrompt',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(name) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'destination',
                  message: 'Destination:',
                  default: (0, _projectGuess.guessProjectDestination)(name)
                }));

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function destinationPrompt(_x2) {
        return _ref3.apply(this, arguments);
      }

      return destinationPrompt;
    }()
  }, {
    key: 'descriptionPrompt',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'description',
                  message: 'Project Description:',
                  default: (0, _projectGuess.guessProjectDescription)()
                }));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function descriptionPrompt() {
        return _ref4.apply(this, arguments);
      }

      return descriptionPrompt;
    }()
  }, {
    key: 'versionPrompt',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'version',
                  message: 'Version:',
                  default: (0, _projectGuess.guessProjectVersion)()
                }));

              case 1:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function versionPrompt() {
        return _ref5.apply(this, arguments);
      }

      return versionPrompt;
    }()
  }, {
    key: 'licensePrompt',
    value: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt('return', this.optionOrPrompt({
                  type: 'list',
                  name: 'license',
                  message: 'License:',
                  choices: [{ name: 'Apache 2.0', value: 'Apache-2.0' }, { name: 'MIT', value: 'MIT' }, { name: 'Mozilla Public License 2.0', value: 'MPL-2.0' }, {
                    name: 'BSD 2-Clause (FreeBSD) License',
                    value: 'BSD-2-Clause-FreeBSD'
                  }, { name: 'BSD 3-Clause (NewBSD) License', value: 'BSD-3-Clause' }, { name: 'Internet Systems Consortium (ISC) License', value: 'ISC' }, { name: 'GNU AGPL 3.0', value: 'AGPL-3.0' }, { name: 'GNU GPL 3.0', value: 'GPL-3.0' }, { name: 'GNU LGPL 3.0', value: 'LGPL-3.0' }, { name: 'Unlicense', value: 'unlicense' }, { name: 'No License (Copyrighted)', value: 'UNLICENSED' }],
                  default: 'MIT'
                }));

              case 1:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function licensePrompt() {
        return _ref6.apply(this, arguments);
      }

      return licensePrompt;
    }()
  }, {
    key: 'authorNamePrompt',
    value: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                return _context7.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'authorName',
                  message: 'Author Name:',
                  default: (0, _projectGuess.guessAuthorName)()
                }));

              case 1:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function authorNamePrompt() {
        return _ref7.apply(this, arguments);
      }

      return authorNamePrompt;
    }()
  }, {
    key: 'authorEmailPrompt',
    value: function () {
      var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                return _context8.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'authorEmail',
                  message: 'Author Email:',
                  default: (0, _projectGuess.guessAuthorEmail)()
                }));

              case 1:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function authorEmailPrompt() {
        return _ref8.apply(this, arguments);
      }

      return authorEmailPrompt;
    }()
  }, {
    key: 'githubUsernamePrompt',
    value: function () {
      var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(authorEmail) {
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                return _context9.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'githubUsername',
                  message: 'GitHub Username:',
                  default: (0, _projectGuess.guessUsername)(authorEmail)
                }));

              case 1:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function githubUsernamePrompt(_x3) {
        return _ref9.apply(this, arguments);
      }

      return githubUsernamePrompt;
    }()
  }, {
    key: 'authorUrlPrompt',
    value: function () {
      var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(githubUsername) {
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                return _context10.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'authorUrl',
                  message: 'Author URL:',
                  default: `https://${githubUsername}.com`
                }));

              case 1:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function authorUrlPrompt(_x4) {
        return _ref10.apply(this, arguments);
      }

      return authorUrlPrompt;
    }()
  }, {
    key: 'repositoryPrompt',
    value: function () {
      var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(githubUsername, name) {
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                return _context11.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'repository',
                  message: 'Repository:',
                  default: `https://github.com/${githubUsername}/${name}`
                }));

              case 1:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function repositoryPrompt(_x5, _x6) {
        return _ref11.apply(this, arguments);
      }

      return repositoryPrompt;
    }()
  }, {
    key: 'homepagePrompt',
    value: function () {
      var _ref12 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(repository) {
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                return _context12.abrupt('return', this.optionOrPrompt({
                  type: 'input',
                  name: 'homepage',
                  message: 'Homepage:',
                  default: repository
                }));

              case 1:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function homepagePrompt(_x7) {
        return _ref12.apply(this, arguments);
      }

      return homepagePrompt;
    }()
  }, {
    key: 'optionOrPrompt',
    value: function () {
      var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(config) {
        return regeneratorRuntime.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return this.yo.optionOrPrompt([config]);

              case 2:
                _context13.t0 = config.name;
                return _context13.abrupt('return', _context13.sent[_context13.t0]);

              case 4:
              case 'end':
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function optionOrPrompt(_x8) {
        return _ref13.apply(this, arguments);
      }

      return optionOrPrompt;
    }()
  }]);

  return YoBasePrompts;
}();

exports.default = YoBasePrompts;